<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Example</title>
    <style>
      html,
      body {
        height: 100%;
        margin: 0;
        overflow: hidden;
        padding: 0;
      }
    </style>
  </head>
  <body>
    <div
      style="
        background-color: #cc84ff; /* Soft White */
        height: 100%;
        overflow: hidden;
        padding: 20px;
      "
    >
      <h1>Example</h1>
      <p>Hello, world!</p>
    </div>
    <script>
      window.__FloatingAppDirectory__ = {};
      window.__FloatingAppDirectory__.colors = [
        "#20B2AA",
        "#ADD8E6",
        "#98FB98",
        "#FFD700",
        "#DDA0DD",
        "#FF6347",
      ];
      window.__FloatingAppDirectory__.apps = [
        {
          title: "Papa",
          url: "https://nextcloud.com/",
          description: "Cloud storage and collaboration platform",
          icon: "https://avatars.githubusercontent.com/u/19211038?s=200&v=4",
        },
        {
          title: "Nextcloud",
          url: "https://nextcloud.com/",
          description: "Cloud storage and collaboration platform",
          icon: "https://avatars.githubusercontent.com/u/19211038?s=200&v=4",
        },
        {
          title: "Keycloak",
          url: "https://www.keycloak.org/",
          description: "Open Source Identity and Access Management",
          icon: "https://avatars.githubusercontent.com/u/4921466?s=200&v=4",
        },
        {
          title: "Jitsi Meet",
          url: "https://jitsi.org/jitsi-meet/",
          description: "Open source video conferencing",
          icon: "https://avatars.githubusercontent.com/u/3671647?s=200&v=4",
        },
        {
          title: "Mattermost",
          url: "https://mattermost.com/",
          description: "Open source Slack-alternative",
          icon: "https://avatars.githubusercontent.com/u/9828093?s=200&v=4",
        },
        {
          title: "GitLab",
          url: "https://about.gitlab.com/",
          description: "DevOps platform",
          icon: "https://avatars.githubusercontent.com/u/22105643?s=200&v=4",
        },
        {
          title: "Bookstack",
          url: "https://www.bookstackapp.com/",
          description: "Simple & Free Wiki Software",
        },
        {
          title: "Grafana",
          url: "https://grafana.com/",
          description: "Open source platform for monitoring and observability",
          icon: "https://avatars.githubusercontent.com/u/7195757?s=200&v=4",
        },
        {
          title: "Wekan",
          url: "https://wekan.github.io/",
          description: "The open-source kanban",
          icon: "https://avatars.githubusercontent.com/u/11725037?s=200&v=4",
        },
        {
          title: "Diaspora",
          url: "https://diasporafoundation.org/",
          description: "Decentralized social network",
          icon: "https://avatars.githubusercontent.com/u/293207?s=200&v=4",
        },
        {
          title: "Ghost",
          url: "https://ghost.org/",
          description: "Professional publishing platform",
          icon: "https://avatars.githubusercontent.com/u/2178663?s=200&v=4",
          icon: "https://avatars.githubusercontent.com/u/10137?v=4",
        },
        {
          title: "Wallabag",
          url: "https://wallabag.org/",
          description: "Save and classify articles. Read them later. Freely.",
        },
        {
          title: "Taiga",
          url: "https://taiga.io/",
          description: "Open Source Project Management Tool",
        },
        {
          title: "PeerTube",
          url: "https://joinpeertube.org/",
          description: "A decentralized video hosting network",
          icon: "https://avatars.githubusercontent.com/u/22838253?s=200&v=4",
        },
        {
          title: "Mastodon",
          url: "https://mastodon.social/",
          description: "Social networking, back in your hands",
          icon: "https://avatars.githubusercontent.com/u/24979032?s=200&v=4",
        },
        {
          title: "Bitwarden",
          url: "https://bitwarden.com/",
          description: "Open source password management",
          icon: "https://avatars.githubusercontent.com/u/15990069?s=200&v=4",
        },
        {
          title: "Rocket.Chat",
          url: "https://rocket.chat/",
          description: "Free, Open Source, Enterprise Team Chat",
          icon: "https://avatars.githubusercontent.com/u/12508788?s=200&v=4",
        },
        {
          title: "Mailcow",
          url: "https://mailcow.email/",
          description:
            "Mailserver suite based on Dovecot, Postfix and other open source software",
          icon: "https://avatars.githubusercontent.com/u/23747925?s=200&v=4",
        },
        {
          title: "Jellyfin",
          url: "https://jellyfin.org/",
          description: "Free Software Media System",
          icon: "https://avatars.githubusercontent.com/u/45698031?s=200&v=4",
        },
      ];
    </script>
    <!-- FLOATING APP DIRECTORY START -->
    <style>
      /* FLOATING BUTTON STYLES START */
      .FloatingAppDirectory--floating-btn {
        cursor: pointer;
        position: fixed;
        left: 50%;
        top: 50%;
        transform: translate(-50%, -50%);
        background-color: #0b89ff;
        color: #f7f7f7;
        border-width: 2px;
        border-color: black;
        border-style: solid;
        border-radius: 100px;
        width: 40px;
        height: 40px;
        font-size: 0;
        z-index: 2147483647;
        transition: left 0.7s cubic-bezier(0.2, 2, 0.07, 1),
          top 0.7s cubic-bezier(0.2, 2, 0.07, 1), background-color 0.2s ease-in;
        overflow: hidden;
      }
      .FloatingAppDirectory--floating-btn svg {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        width: 42px;
        height: 42px;
        padding: 5px;
        box-sizing: border-box;
      }
      .FloatingAppDirectory--line {
        stroke-width: 9;
        stroke-linecap: round;
        stroke: white;
        transition: all 500ms;
      }
      .FloatingAppDirectory--top {
        transform-origin: 26px 40px;
      }
      .FloatingAppDirectory--middle {
        stroke-dasharray: 60 60;
      }
      .FloatingAppDirectory--bottom {
        transform-origin: 26px 60px;
      }
      .FloatingAppDirectory--floating-btn.FloatingAppDirectory--open {
        background-color: #ff5858;
      }
      .FloatingAppDirectory--floating-btn.FloatingAppDirectory--open
        .FloatingAppDirectory--top {
        transform: rotate(45deg);
      }
      .FloatingAppDirectory--floating-btn.FloatingAppDirectory--open
        .FloatingAppDirectory--middle {
        stroke-dasharray: 1 60;
        stroke-dashoffset: -30;
      }
      .FloatingAppDirectory--floating-btn.FloatingAppDirectory--open
        .FloatingAppDirectory--bottom {
        transform: rotate(-45deg);
      }
      .FloatingAppDirectory--notransition {
        transition: none !important;
      }
      .FloatingAppDirectory--modal {
        position: fixed;
        top: 0;
        overflow-y: auto;
        left: 0;
        width: 100%;
        height: 100vh;
        background-color: rgba(247, 247, 247);
        display: flex;
        justify-content: flex-start;
        align-items: flex-start;
        visibility: hidden;
        opacity: 0;
        transition: visibility 0s 0.2s, opacity 0.2s ease-in;
        z-index: 2147483645;
      }
      .FloatingAppDirectory--modal.FloatingAppDirectory--open {
        visibility: visible;
        opacity: 1;
        transition: opacity 0.2s ease-in;
      }
      @media (prefers-color-scheme: dark) {
        .FloatingAppDirectory--modal {
          background-color: rgba(30, 30, 30);
        }
      }
      /* FLOATING BUTTON STYLES END */

      /* APP DIRECTORY STYLES START */
      .FloatingAppDirectory--app-directory {
        flex-grow: 1;
        overflow-y: auto;
        padding: 40px;
        display: flex;
        flex-wrap: wrap;
        width: 100%;
        justify-content: space-between;
        font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto,
          Oxygen-Sans, Ubuntu, Cantarell, "Helvetica Neue", sans-serif;
      }
      .FloatingAppDirectory--app-box {
        width: 200px;
        height: 200px;
        margin: 20px;
        background-color: #ffffff;
        background-size: cover;
        border-color: #000;
        border-width: 6px;
        border-radius: 10px;
        border-style: solid;
        position: relative;
        overflow: hidden;
        cursor: pointer;
      }
      .FloatingAppDirectory--app-overlay {
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        background: rgba(0, 0, 0, 0.7);
        opacity: 0;
        transition: opacity 0.3s;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        padding: 10px;
        box-sizing: border-box;
        pointer-events: none;
      }
      .FloatingAppDirectory--app-box:hover .FloatingAppDirectory--app-overlay {
        opacity: 1;
      }
      .FloatingAppDirectory--app-overlay a {
        display: block;
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        z-index: 2147483646;
        cursor: pointer;
        pointer-events: auto;
      }
      .FloatingAppDirectory--app-overlay .FloatingAppDirectory--app-title,
      .FloatingAppDirectory--app-overlay
        .FloatingAppDirectory--app-description {
        margin: 5px 0;
        color: #fff;
        text-align: center;
      }
      .FloatingAppDirectory--app-overlay .FloatingAppDirectory--app-title {
        font-weight: bold;
        font-size: 28px;
      }
      .FloatingAppDirectory--app-main-title {
        font-size: 28px;
        font-weight: bold;
        color: #000;
        display: flex;
        justify-content: center;
        align-items: center;
        height: 100%;
        transition: opacity 0.3s;
        text-align: center;
      }
      .FloatingAppDirectory--app-box:hover
        .FloatingAppDirectory--app-main-title {
        opacity: 0;
      }
      @media (prefers-color-scheme: dark) {
        .FloatingAppDirectory--app-box {
          border-color: #fff;
        }
      }
      /* APP DIRECTORY STYLES END */
    </style>
    <div id="FloatingAppDirectory--modal" class="FloatingAppDirectory--modal">
      <div class="FloatingAppDirectory--app-directory"></div>
    </div>
    <button
      id="FloatingAppDirectory--toggleBtn"
      class="FloatingAppDirectory--floating-btn"
    >
      <div class="FloatingAppDirectory--main-nav-toggle">
        <svg viewBox="0 0 100 100">
          <path
            class="FloatingAppDirectory--line FloatingAppDirectory--top"
            d="M 20,30 H 80"
          />
          <path
            class="FloatingAppDirectory--line FloatingAppDirectory--middle"
            d="M 20,50 H 80"
          />
          <path
            class="FloatingAppDirectory--line FloatingAppDirectory--bottom"
            d="M 20,70 H 80"
          />
        </svg>
      </div>
    </button>
    <script>
      (function () {
        if (!window.__FloatingAppDirectory__) {
          window.__FloatingAppDirectory__ = {};
        }
        if (!__FloatingAppDirectory__.colors) {
          window.__FloatingAppDirectory__.colors = [
            FLOATING_APP_DIRECTORY_COLORS,
          ];
        }
        if (!window.__FloatingAppDirectory__.apps) {
          window.__FloatingAppDirectory__.apps = [FLOATING_APP_DIRECTORY_APPS];
        }
        // FLOATING BUTTON SCRIPT START
        var padding = 10;
        var toggleBtn = document.getElementById(
          "FloatingAppDirectory--toggleBtn"
        );
        var modal = document.getElementById("FloatingAppDirectory--modal");
        var isMouseDown = false;
        var startPos = { x: 0, y: 0 };
        var btnPos = { x: 0, y: 0 };
        function getSnapPositions() {
          return [
            {
              x: padding + toggleBtn.offsetWidth / 2,
              y: padding + toggleBtn.offsetHeight / 2,
            },
            {
              x: window.innerWidth / 2,
              y: padding + toggleBtn.offsetHeight / 2,
            },
            {
              x: window.innerWidth - padding - toggleBtn.offsetWidth / 2,
              y: padding + toggleBtn.offsetHeight / 2,
            },
            {
              x: padding + toggleBtn.offsetWidth / 2,
              y: window.innerHeight / 2,
            },
            {
              x: window.innerWidth - padding - toggleBtn.offsetWidth / 2,
              y: window.innerHeight / 2,
            },
            {
              x: padding + toggleBtn.offsetWidth / 2,
              y: window.innerHeight - padding - toggleBtn.offsetHeight / 2,
            },
            {
              x: window.innerWidth / 2,
              y: window.innerHeight - padding - toggleBtn.offsetHeight / 2,
            },
            {
              x: window.innerWidth - padding - toggleBtn.offsetWidth / 2,
              y: window.innerHeight - padding - toggleBtn.offsetHeight / 2,
            },
          ];
        }
        var snapPositions = getSnapPositions();
        toggleBtn.classList.add("FloatingAppDirectory--notransition");
        if (
          !localStorage.getItem("__FloatingAppDirectory__snapPositionIndex")
        ) {
          localStorage.setItem(
            "__FloatingAppDirectory__snapPositionIndex",
            "1"
          );
        }
        var storedSnapIndex = localStorage.getItem(
          "__FloatingAppDirectory__snapPositionIndex"
        );
        if (storedSnapIndex !== null) {
          var pos = snapPositions[storedSnapIndex];
          toggleBtn.style.left = pos.x + "px";
          toggleBtn.style.top = pos.y + "px";
          setTimeout(function () {
            toggleBtn.classList.remove("FloatingAppDirectory--notransition");
          }, 0);
        } else {
          toggleBtn.classList.remove("FloatingAppDirectory--notransition");
        }
        toggleBtn.addEventListener("mousedown", function (e) {
          isMouseDown = true;
          toggleBtn.classList.add("FloatingAppDirectory--notransition");
          var rect = toggleBtn.getBoundingClientRect();
          startPos = { x: e.clientX, y: e.clientY };
          btnPos = {
            x: rect.left + toggleBtn.offsetWidth / 2,
            y: rect.top + toggleBtn.offsetHeight / 2,
          };
          e.preventDefault();
        });
        document.addEventListener("mouseup", function () {
          isMouseDown = false;
          toggleBtn.classList.remove("FloatingAppDirectory--notransition");
          repositionButton();
        });
        document.addEventListener("mousemove", function (e) {
          if (!isMouseDown) return;
          var dx = e.clientX - startPos.x;
          var dy = e.clientY - startPos.y;
          var newLeft = btnPos.x + dx;
          var newTop = btnPos.y + dy;
          newLeft = Math.min(
            Math.max(newLeft, padding + toggleBtn.offsetWidth / 2),
            window.innerWidth - toggleBtn.offsetWidth / 2 - padding
          );
          newTop = Math.min(
            Math.max(newTop, padding + toggleBtn.offsetHeight / 2),
            window.innerHeight - toggleBtn.offsetHeight / 2 - padding
          );
          toggleBtn.style.left = newLeft + "px";
          toggleBtn.style.top = newTop + "px";
        });
        toggleBtn.addEventListener("click", function (e) {
          if (e.clientX === startPos.x && e.clientY === startPos.y) {
            modal.classList.toggle("FloatingAppDirectory--open");
            toggleBtn.classList.toggle("FloatingAppDirectory--open");
            if (modal.classList.contains("FloatingAppDirectory--open")) {
              document.body.style.overflow = "hidden";
            } else {
              document.body.style.overflow = "";
            }
          }
        });
        var resizeTimeout;
        window.addEventListener("resize", function () {
          clearTimeout(resizeTimeout);
          resizeTimeout = setTimeout(function () {
            snapPositions = getSnapPositions();
            positionBasedOnLocalStorage();
            toggleBtn.classList.remove("FloatingAppDirectory--notransition");
          }, 500);
        });
        function positionBasedOnLocalStorage() {
          storedSnapIndex = localStorage.getItem(
            "__FloatingAppDirectory__snapPositionIndex"
          );
          if (storedSnapIndex !== null) {
            var pos = snapPositions[storedSnapIndex];
            toggleBtn.style.left = pos.x + "px";
            toggleBtn.style.top = pos.y + "px";
          }
        }
        function repositionButton() {
          var rect = toggleBtn.getBoundingClientRect();
          var btnCurrentPos = { x: rect.left, y: rect.top };
          var closestIndex = snapPositions.reduce(function (
            prevIndex,
            currPos,
            currIndex
          ) {
            var prevDist = Math.hypot(
              btnCurrentPos.x - snapPositions[prevIndex].x,
              btnCurrentPos.y - snapPositions[prevIndex].y
            );
            var currDist = Math.hypot(
              btnCurrentPos.x - currPos.x,
              btnCurrentPos.y - currPos.y
            );
            return prevDist < currDist ? prevIndex : currIndex;
          },
          0);
          toggleBtn.style.left = snapPositions[closestIndex].x + "px";
          toggleBtn.style.top = snapPositions[closestIndex].y + "px";
          localStorage.setItem(
            "__FloatingAppDirectory__snapPositionIndex",
            closestIndex
          );
        }
        // FLOATING BUTTON SCRIPT END

        // APP DIRECTORY SCRIPT START
        function hashString(str) {
          var hash = 0;
          for (var i = 0; i < str.length; i++) {
            hash = (hash << 5) - hash + str.charCodeAt(i);
            hash |= 0;
          }
          return hash;
        }
        function createAppElement(tag, className, text) {
          var element = document.createElement(tag);
          if (className) element.classList.add(className);
          if (text) element.textContent = text;
          return element;
        }
        var appDirectory = document.querySelector(
          ".FloatingAppDirectory--app-directory"
        );
        var fragment = document.createDocumentFragment();
        for (var i = 0; i < window.__FloatingAppDirectory__.apps.length; i++) {
          var app = window.__FloatingAppDirectory__.apps[i];
          var colors = window.__FloatingAppDirectory__.colors;
          var appBox = createAppElement("div", "FloatingAppDirectory--app-box");
          var mainTitle = createAppElement(
            "div",
            "FloatingAppDirectory--app-main-title",
            app.title
          );
          if (app.icon) {
            appBox.style.backgroundImage = `url('${app.icon}')`;
          } else {
            var colorIndex =
              Math.abs(hashString(app.url || app.title || "")) % colors.length;
            appBox.style.backgroundColor = colors[colorIndex];
            appBox.appendChild(mainTitle);
          }
          var appOverlay = createAppElement(
            "div",
            "FloatingAppDirectory--app-overlay"
          );
          var appLink = createAppElement("a");
          appLink.href = app.url || "#";
          if (app.url) appLink.target = "_blank";
          var appTitle = createAppElement(
            "div",
            "FloatingAppDirectory--app-title",
            app.title
          );
          appOverlay.appendChild(appLink);
          appOverlay.appendChild(appTitle);
          if (app.description) {
            var appDescription = createAppElement(
              "div",
              "FloatingAppDirectory--app-description",
              app.description
            );
            appOverlay.appendChild(appDescription);
          }
          appBox.appendChild(appOverlay);
          fragment.appendChild(appBox);
        }
        appDirectory.appendChild(fragment);
        // APP DIRECTORY SCRIPT END
      })();
    </script>
    <!-- FLOATING APP END -->
  </body>
</html>
